unit form1;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, menus, extctrls, buttons, clipbrd,ShellApi, OleCtrls,
  voicerlibLib_TLB;
  //para compatibilidade com VoicerLib 4.3.0.1_rc57 ou superior
  procedure dg_GetE1Number(Port:Smallint;  sE1: PChar); cdecl; external 'voicerlib.dll'
  procedure dg_GetCallerId(Port:Smallint;  sID: PChar); cdecl; external 'voicerlib.dll'
  procedure dg_ReadDigits(Port:Smallint;   sDig: PChar); cdecl; external 'voicerlib.dll'

Type
   TForm1Cls = class(TForm)
        Frame2 : TGroupbox;
        btnFinaliza: TButton;
        btnLoggerOff: TButton;
        Label4 : TLabel;
        Label3 : TLabel;
        Frame1 : TGroupbox;
        btnLoggerOn: TButton;
        btnInicia: TButton;
        Label2 : TLabel;
        Label1 : TLabel;
        Panel1: TPanel;
        chkMostrarLog: TCheckBox;
        btnLeiaMe: TButton;
        btnSalvarlog: TButton;
        btnLimpaLog: TButton;
        GroupBox1: TGroupBox;
        memStatus: TMemo;
        GroupBox2: TGroupBox;
        memEntrantes: TMemo;
        GroupBox3: TGroupBox;
        memSaintes: TMemo;
        Label5: TLabel;
        lblQtdePlacas: TLabel;
        Label6: TLabel;
        lblQtdeCanais: TLabel;
        Label7: TLabel;
        lblCanaisEmGravacao: TLabel;
        txtCanal: TEdit;
        Label8: TLabel;
        Label9: TLabel;
        txtLimiar: TEdit;
        Label10: TLabel;
        Image1: TImage;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    vlib: Tvoicerlib;
        procedure cmdInicia_Click(Sender: TObject );
        procedure cmdLoggerOff_Click(Sender: TObject );
        procedure cmdLoggerOn_Click(Sender: TObject );
        procedure vlibLoggerEvent(ASender: TObject; Port,
          LoggerStatus: Smallint);
        procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
        procedure btnFinalizaClick(Sender: TObject);
        procedure btnLimpaLogClick(Sender: TObject);
        procedure btnLeiaMeClick(Sender: TObject);
        procedure vlibRecordStop(ASender: TObject; Port, StopStatus: Smallint);
        procedure vlibRecordStart(ASender: TObject; Port: Smallint);
        procedure vlibR2Received(ASender: TObject; Port, Signal: Smallint);
        procedure btnSalvarlogClick(Sender: TObject);
        procedure vlibDigitDetected(ASender: TObject; Port, Digit: Smallint);
        procedure vlibE1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
          AlarmData: Smallint);
        procedure vlibCallerID(ASender: TObject; Port: Smallint;
          const Number: WideString);
        procedure FormCreate(Sender: TObject);
        procedure vlibErrorDetected(ASender: TObject; Card,
          ErrorCode: Smallint);
        private
        public
          procedure MostraStatus(nPort:longint;sMess:string);
          procedure MostraStatus1(nPort:longint;sMess:string);
          procedure MostraStatus2(nPort:longint;sMess:string);
      end;

   TrcEstatistica = record
      dtInicioLogger: TDateTime;
      dtFimLogger: TDateTime;
      dtDuracao: TDateTime;
      nQtdeLogger: integer;
   end;

var
  Form1Cls : TForm1Cls;
  nIndice: array[1..360] of integer;
  nEspera: array[1..360] of integer;
  rcEstat : array[1..360] of TrcEstatistica;
  nQtdePlacas: Integer;
  nQtdeCanais: Integer;
  nCanaisGravando : Integer;
  sReturn    : array [0..255] of Char;
  
const
  R2 = 0;
  MFC = 1;

implementation
{$R *.dfm}

procedure TForm1Cls.MostraStatus(nPort:longint;sMess:string);
var
  sMsg : string;
begin
  if not chkMostrarLog.Checked then
    Exit;

  if Trim(txtCanal.Text) <> '' then
    if not ((nPort = StrToInt(txtCanal.Text)) or ((nPort - 30) = StrToInt(txtCanal.Text))) then
      Exit;

  if (nPort > 0) then
    sMsg := '<'+TimeToStr(Time)+'>'+'(Porta '+IntToStr(nPort)+') '+sMess
  else
    sMsg := '<'+TimeToStr(Time)+'>'+sMess;

  memStatus.Lines.Add(sMsg);
end;

//Ligacoes de Entrada
procedure TForm1Cls.MostraStatus1(nPort:longint;sMess:string);
var
  sMsg : string;
begin
  if not chkMostrarLog.Checked then
    Exit;

  if (nPort > 0) then
    sMsg := '<'+TimeToStr(Time)+'>'+'(Porta '+IntToStr(nPort)+') '+sMess
  else
    sMsg := '<'+TimeToStr(Time)+'>'+sMess;
  memEntrantes.Lines.Add(sMsg);
end;

//Ligacoes de Saida
procedure TForm1Cls.MostraStatus2(nPort:longint;sMess:string);
var
  sMsg : string;
begin
  if not chkMostrarLog.Checked then
    Exit;

  if (nPort > 0) then
    sMsg := '<'+TimeToStr(Time)+'>'+'(nPort '+IntToStr(nPort)+') '+sMess
  else
    sMsg := '<'+TimeToStr(Time)+'>'+sMess;
  memSaintes.Lines.Add(sMsg);
end;

procedure TForm1Cls.cmdInicia_Click(Sender: TObject );
var
  nRet : longint;
  i: Integer;
begin

  MostraStatus(0, 'Iniciando Placa...' );

  //Inicializa a Voicerlib
  Screen.Cursor := crHourglass;
  nRet := vlib.StartVoicerLib;
  //Trata o retorno da inicializacao
  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  Screen.Cursor := crDefault;

  //Trata o retorno da Inicializacao
  if (nRet <> DG_EXIT_SUCCESS) then
    MostraStatus(0,'Nao foi possivel inicializar a placa.nRet '+ IntToStr(nRet) + ' (' + sReturn + ') ')
  else
  begin
    MostraStatus(0 ,'Placa inicializada com sucesso' );
    //Habilita o recurso de depuracao da VoicerLib
    vlib.EnableDebug(623);
    nQtdePlacas := vlib.CardsCount;
    nQtdeCanais := vlib.GetPortsCount div 2;
    lblQtdePlacas.Caption := IntToStr(nQtdePlacas);
    lblQtdeCanais.Caption := IntToStr(nQtdeCanais);
    MostraStatus(0,'Versao Driver= ' + IntToStr(vlib.DriverVersion));
    MostraStatus(0,'Versao Firmware= ' + IntToStr(vlib.FirmwareVersion));

    for i := 1 to vlib.GetCardsCount do
    begin
      //Configura o sincronismo da placa => MASTER com sincronismo externo no E1 A
      vLib.SetCardSyncMode(i, MASTER_SYNC_A);
      MostraStatus(i , 'Sincronismo da placa configurado com sucesso');
      vLib.SetAlarmMode(i,ALARM_AUTOMATIC_NOTIFY);
      MostraStatus(i , 'Alarme automatico configurado com sucesso');
    end;
  end;
end;

procedure TForm1Cls.cmdLoggerOff_Click(Sender: TObject );
var
  i,j,k: longint;
  nRet: longint;
begin

  for i:= 1 to nQtdePlacas do //Qtde total de placas
  begin
    k := (60* (i -1)+1);
    for j := k to  (k + 30 - 1) do // de 1-30  61-90  ....
    begin
      //Desativa controle de gravao de todas as portas instaladas no sistema
      nRet := vlib.DestroyLoggerCCS(j);
      if (nret <> DG_EXIT_SUCCESS) then
        MostraStatus(j, 'Erro ao desativar controle de gravao.nRet '+ IntToStr(nret))
      else
        MostraStatus(j, 'Controle de gravao *Desativado*');
    end;
  end;
end;

procedure TForm1Cls.cmdLoggerOn_Click(Sender: TObject );
var
  i,j,k: Integer;
  nRet: Integer;
begin

  nCanaisGravando := 0;

  //Ativa controle de gravao
  for i:= 1 to nQtdePlacas do //Qtde total de placas
  begin
    k := (60* (i -1))+1;
    for j := k to (k + 30 - 1) do // de 1-30  61-90  ....
    begin

      //Cria thread de logger
      nret := vlib.CreateLoggerCCS(j, 1);

      if (nret <> DG_EXIT_SUCCESS ) then
        MostraStatus(j, 'Erro ao criar controle de gravao.nRet '+ IntToStr(nret))
      else
      begin
        MostraStatus(j, 'Criou controle de gravao');
        //Seta silence threshold
        //nret := vlib.SetLoggerSilenceThreshold(j,StrToInt(txtLimiar.Text));
        //if nret <> DG_EXIT_SUCCESS then
        //  MostraStatus(j,'Erro ao setar limiar de silncio.nRet '+ IntToStr(nret));
        //Seta formato de gravacao
        nret := vlib.SetRecordFormat(j, ffWavePCM);
        if nret <> DG_EXIT_SUCCESS then
          MostraStatus(j,'Erro ao setar formato de gravao como WavePCM.nRet '+ IntToStr(nret));
        //Habilita amostras para placa
        nret := vlib.EnableInputBuffer(j,DG_DISABLE);
        if nret <> DG_EXIT_SUCCESS then
          MostraStatus(j,'Erro ao habilitar amostras para a placa.nRet '+ IntToStr(nret))

      end;
    end;
  end;
end;

procedure TForm1Cls.vlibLoggerEvent(ASender: TObject; Port,
  LoggerStatus: Smallint);
var
  sTipo,sE1, sBina: String;
  nRet : integer;
  dia, mes, ano: word;
  h, m, s, c: word;

  cE1: array[0..256] of char;
begin

  case LoggerStatus  of
    LOGGER_FREE_WITH_BILLING:      MostraStatus(Port , '(OnLoggerEvent) - Linha de Assinante Livre com Tarifao');

    LOGGER_BUSY:                   MostraStatus(Port , '(OnLoggerEvent) - Ocupada');

    LOGGER_NUMBER_CHANGED:         MostraStatus(Port , '(OnLoggerEvent) - Linha de assinante mudado');

    LOGGER_CONGESTION:             MostraStatus(Port , '(OnLoggerEvent) - Congestionamento');

    LOGGER_FREE_WITHOUT_BILLING:   MostraStatus(Port , '(OnLoggerEvent) - Assinante Livre sem tarifao');

    LOGGER_FREE_RETENTION:         MostraStatus(Port , '(OnLoggerEvent) - Assinante Livre com tarifao e colocar retenso sob ctrl do assinante chamado');

    LOGGER_LEVEL_NUMBER_AVAILABLE: MostraStatus(Port , '(OnLoggerEvent) - Nvel ou Numero Vago');

    LOGGER_B_ENDCALL:              //Quando o assinante B desliga no significa necessariamente que a ligao terminou
                                   MostraStatus(Port , '(OnLoggerEvent) - Assinante B desligou');

    LOGGER_B_RETURN:               //Ocorre aps o LOGGER_B_ENDCALL caso o assinante B retorna  ligao
                                   MostraStatus(Port , '(OnLoggerEvent) - Assinante B retornou a ligao');

    LOGGER_LINEREADY:
    begin
      //LineReady significa o local do inicio efetivo da conversao
      dg_GetE1Number( Port,cE1 ); //pega nmero do E1
      sE1 :=cE1;

      dg_GetCallerID( Port,cE1 ); //pega BINA
      sBina := cE1;


      if vlib.GetLoggerCallType(Port) = INCOMINGCALL then
        sTipo := 'Entrante'
      else
        sTipo := 'Sainte';

      MostraStatus(Port , '(OnLoggerEvent) - Logger LineReady '+sTipo+'(Caller ID: '+sBina+', E1 Number: '+sE1+')' );
      if sTipo =  'Entrante' then
        MostraStatus1(Port ,'(OnLoggerEvent) - ' +  sTipo+ '(ID: '+sBina+', E1 N: '+sE1+')' )
      else
        MostraStatus2(Port ,'(OnLoggerEvent) - '+ sTipo+ '(ID: '+sBina+', E1 N: '+sE1+')' );

      DecodeDate(Date, ano, mes, dia);
      DecodeTime(Time, h, m, s, c);
      ForceDirectories(ExtractFilePath(Application.ExeName) + Format('\%.2d', [h]));

      //Habilita InputBuffer
      nRet := vlib.EnableInputBuffer(Port, 1);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(Port,'Erro ao habilitar InputBuffer.nRet ' + IntToStr(nRet)); 

if CheckBox1.Checked then
begin 
      //Inicia gravacao
      nret := vlib.RecordFile(Port, ExtractFilePath(Application.ExeName) +
                                  Format('\%.2d\G%s%.2d-%04d%.2d%.2d_%.2d%.2d%.2d.wav', [h,'Logger', Port, ano, mes, dia, h, m, s]), '');
      if (nret <> DG_EXIT_SUCCESS) then
        MostraStatus(Port , '(OnLoggerEvent) - Erro ao gravar arquivo.nRet ' + IntToStr(nRet))
      else
         MostraStatus(Port , '(OnLoggerEvent) - Iniciando gravao');
end;

      //Estatistica
      rcEstat[Port].dtInicioLogger := Now;
    end;

    LOGGER_LINEOFF:
    begin
      //LineOff significa o local do trmino efetivo da conversao
      MostraStatus(Port , '(OnLoggerEvent) - Logger LineOff');

if CheckBox1.Checked then
begin 
      //Finaliza gravao
      nret := vlib.StopRecordFile(Port);
      if (nret <> DG_EXIT_SUCCESS) then
        MostraStatus(Port , '(OnLoggerEvent) - Erro ao interromper gravao.nRet ' + IntToStr(nRet))
      else
        MostraStatus(Port , '(OnLoggerEvent) - Gravao finalizada');
end;

      //Estatistica
      rcEstat[Port].dtFimLogger := Now;
      rcEstat[Port].dtDuracao := rcEstat[Port].dtFimLogger - rcEstat[Port].dtInicioLogger;
      Inc(rcEstat[Port].nQtdeLogger);
      MostraStatus(Port,IntToStr(rcEstat[Port].nQtdeLogger));

    end;
  end;
end;

procedure TForm1Cls.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //Se certifica que o driver sera finalizado antes de fechar o programa
  if (vlib.DriverEnabled) then
  begin
    Application.MessageBox('Voc deve finalizar a VoicerLib antes de fechar a aplicao','Aviso',MB_OK);
    CanClose := false;
  end;
end;

procedure TForm1Cls.btnFinalizaClick(Sender: TObject);
var
  nRet : Integer;
begin
  //Finaliza a VoicerLib
  nRet := vlib.ShutdownVoicerlib;
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(0 ,'Erro ao finalizar a VoicerLib.nRet ' + IntToStr(nRet))
  else
    MostraStatus(0 ,'A VoicerLib foi finalizada com sucesso!');
end;

procedure TForm1Cls.btnLimpaLogClick(Sender: TObject);
begin
  memStatus.Clear;
end;

procedure TForm1Cls.btnLeiaMeClick(Sender: TObject);
var
  L: String;
begin
  L := ExtractFilePath(Application.ExeName) + 'Leiame.txt';
  ShellExecute(0,nil,Pchar(L),nil,nil,SW_NORMAL);
end;

procedure TForm1Cls.vlibRecordStop(ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet : Integer;
begin
  MostraStatus(Port,'(OnRecordStop) - Parou de gravar');
  nCanaisGravando :=  nCanaisGravando - 1;
  lblCanaisEmGravacao.Caption := intToStr(nCanaisGravando);

  //Interrompe o envio de amostras da placa para a aplicao
  nRet := vlib.DisableInputBuffer(Port);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(Port,'(OnRecordStop) - Erro ao desabilitar InputBuffer.nRet ' + IntToStr(nRet))
  else
    MostraStatus(Port,'(OnRecordStop) - InputBuffer desabilitado com sucesso');
end;

procedure TForm1Cls.vlibRecordStart(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port,'(OnRecordStart) - Gravando...');
  nCanaisGravando :=  nCanaisGravando + 1;
  lblCanaisEmGravacao.Caption  := IntToStr(nCanaisGravando);
end;

procedure TForm1Cls.vlibR2Received(ASender: TObject; Port,
  Signal: Smallint);
  var x: Integer;
begin
  if Port <= 60 then
    x := Port
  else
    x := Port - (Port div 60)*60;

  if x > 30 then
    MostraStatus(Port,'R2 ---> ' + IntToStr(Signal))
  else
    MostraStatus(Port,'R2 --------------------------> ' + IntToStr(Signal));
end;

procedure TForm1Cls.btnSalvarlogClick(Sender: TObject);
begin
  memStatus.Lines.SaveToFile(ExtractFilePath(Application.ExeName) + 'Log.txt');
  memEntrantes.Lines.SaveToFile(ExtractFilePath(Application.ExeName) + 'Log_Entrantes.txt');
  memSaintes.Lines.SaveToFile(ExtractFilePath(Application.ExeName) + 'Log_Saintes.txt');
  MostraStatus(0,'Log salvo com sucesso');
end;

procedure TForm1Cls.vlibDigitDetected(ASender: TObject; Port,
  Digit: Smallint);
  var x: Integer;
begin
  if Port <= 60 then
    x := Port
  else
    x := Port - (Port div 60)*60;

  if x > 30 then
    MostraStatus(Port,'MF --------> ' + Chr(Digit))
  else
    MostraStatus(Port,'MF ---------------------> ' + Chr(Digit));
end;

procedure TForm1Cls.vlibE1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
  AlarmData: Smallint);
begin
  case AlarmCode of
    ALARM_RSLIP:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Escorregamento (problema de sincronismo)');
    end;

    ALARM_RAIS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Alarme remoto ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Alarme remoto OFF');
    end;

    ALARM_AISS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme OFF');
    end;

    ALARM_AIS16S:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 OFF');
    end;

    ALARM_LOSS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Perda de sinal ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Perda de sinal OFF');
    end;

    ALARM_CRC4SYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Reservado ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Reservado OFF');
    end;

    ALARM_MFSYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro OFF');
    end;

    ALARM_SYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro ON')
      else
        MostraStatus(0,'(OnE1Alarm) - Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro OFF');
    end;
  end;
end;

procedure TForm1Cls.vlibCallerID(ASender: TObject; Port: Smallint;
  const Number: WideString);
begin
  MostraStatus(Port,'(OnCallerID) - CallerID:' + Number);
end;

procedure TForm1Cls.FormCreate(Sender: TObject);
var
  cVersao : array[0..255] of Char;
  nRet : Integer;
begin

  //Verifica a versao da dll e ocx da voicerlib
  nRet := vlib.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL -> ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := vlib.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');

  if DirectoryExists('\Arquivos de Programas') then
    vlib.ConfigPath := '\Arquivos de Programas\VoicerLib4'
  else
  begin
    if DirectoryExists('\Program Files') then
      vlib.ConfigPath := '\Program Files\VoicerLib4'      
  end;

end;

procedure TForm1Cls.vlibErrorDetected(ASender: TObject; Card,
  ErrorCode: Smallint);
begin
  MostraStatus(0,'(OnErrorDetected) - Erro: ' + IntToStr(ErrorCode));
end;

end.
